%{
#define YYSTYPE double
#include "parser.h"
extern YYSTYPE yylval;
%}

%option noyywrap

%%

\.[0-9]+    |
[0-9]+(\.[0-9]*)?([eE][+-]?[0-9]+)? { yylval = atof (yytext); return NUMBER; }
[-+*/^()=]     { return *yytext; }
[ \t\n]        ;
.              { yyerror("Unknown character.");}

%%

int yyerror(char *msg)
{
   printf("%s\n", msg);
}
