%{
#define YYSTYPE double
#include "parser.h"
#include <math.h>
#define  YYTRACE
%}

%token NUMBER
%start kif

%%

kif   :
   | kif expr '='    { printf ("%.16g\n", $2); $$=$2; }
   ;

expr  : term         { $$ = $1; }
   | expr '+' term   { $$ = $1 + $3; }
   | expr '-' term   { $$ = $1 - $3; }
   ;

term  : fact         { $$ = $1; }
   | term '*' fact   { $$ = $1 * $3; }
   | term '/' fact   { $$ = $1 / $3; }
   ;

fact  : num          { $$ = $1; }
   | fact '^' num    { $$ = pow ($1,$3); }
   ;

num   : val       { $$ = $1; }
   | '-' num      { $$ = -$2; }
   | '+' num      { $$ = $2; }
   ;

val   : NUMBER       { $$ = $1; }
   | '(' expr ')'    { $$ = $2; }
   ;
%%


